SystemOrganization addCategory: #'O-Benchmarks'!

BenchmarkGameSuite subclass: #OstBenchGameSuite
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Benchmarks'!

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 17:04'!
benchBinaryTrees
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil: [ OstBGBinaryTrees defaultProblemSize ].

	[ | bench |
	  bench  := OstBGBinaryTrees new.
	  result := bench binarytrees: problemSize to: (TextStream with: ByteString new).
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchChameleons
	| result problemSize |
	
	self error: 'This benchmark seems to be currently broken in the OmniST implementation.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameleons defaultProblemSize ].
	
	[ result := OstBGChameleons chameneos: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 17:04'!
benchChameneosRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameneosRedux defaultProblemSize ].
	

	[report := TextStream with: ByteString new.
	 result := OstBGChameneosRedux new runBenchMark: problemSize on: report
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 17:04'!
benchFannkuchRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGFannkuchRedux defaultProblemSize ].
	

	[report := TextStream with: ByteString new.
	 result := OstBGFannkuchRedux fannkuchRedux: problemSize to: report
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 17:04'!
benchFasta
	| out problemSize |
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil:      [ OstBGFasta defaultProblemSize ].  
	
	[out := TextStream with: ByteString new.
	 OstBGFasta fasta: problemSize to: out. ] omni: domain.

	^ out! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 17:05'!
benchKNucleotide
	| bench input result problemSize output |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGKNucleotide defaultProblemSize ].
	
	[bench  := OstBGKNucleotide new.
	 input  := ReadStream on: (BGFastaCache forFasta: problemSize).
	 result := TextStream with: ByteString new.
	 output := bench knucleotide5From: input to: result.
	] omni: domain.

	^ output! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 00:24'!
benchMandelbrot
	| result bench problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGMandelbrot defaultProblemSize ].
							
	[ result := OstArray new: problemSize * problemSize / 8.
	  bench  := OstBGMandelbrot new.
	  bench mandelbrot2: problemSize to: result.
	] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 00:23'!
benchMeteor
	| problemSize result |
	problemSize := self problemSize
						ifNotNil: [:ps | ps ]
						ifNil:    [ OstBGMeteor defaultProblemSize ].
	
	[result := OstBGMeteor meteor: problemSize] omni: domain.
	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchNBody
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ OstBGNBody defaultProblemSize ].

	[ OstBGNBody nbody: problemSize ] omni: domain! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:09'!
benchPiDigits
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGPiDigits defaultProblemSize ].
	[ result := OstBGPiDigits piDigits: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 15:03'!
benchRegexDNA
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGRegexDNA defaultProblemSize ].
	
	[OstBGRegexDNA regexdna: problemSize] omni: domain.! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/5/2013 00:21'!
benchReverseComplement
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGReverseComplement defaultProblemSize ].
	
	[OstBGReverseComplement revcomp: problemSize] omni: domain! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 6/4/2013 23:22'!
benchSpectralNorm
	| bench problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGSpectralNorm defaultProblemSize ].

	[ bench  := OstBGSpectralNorm new.
	  result := bench spectralnorm: problemSize ] omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 15:51'!
benchThreadRing
	| problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BGThreadRing defaultProblemSize ].

	[ result := BGThreadRing threadring: problemSize ]  omni: domain.

	^ result! !

!OstBenchGameSuite methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:06'!
setUp
	domain := OstDomain new.! !

SMarkCompiler subclass: #OstBenchCompiler
	instanceVariableNames: 'domain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Benchmarks'!

!OstBenchCompiler methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:09'!
benchCompiler
	[super benchCompiler] omni: domain! !

!OstBenchCompiler methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:09'!
setUp
	domain := OstDomain new.! !

SMarkSlopstone subclass: #OstBenchSlopstone
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Benchmarks'!

!OstBenchSlopstone class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 17:08'!
initialize
	OstObject omnifyClass: self.! !

!OstBenchSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 17:43'!
benchStone
	| n |
	n := self problemSize.
	n > SmallInteger maxVal
		ifTrue: [ self error: 'Count exceeded max small int.' ].
	
	[o := obj new.
	 1 to: n do: [:i | self doIntAdd         ].
	 1 to: n do: [:i | self doFloatAdd       ].
	 1 to: n do: [:i | self doStringAccess   ].
	 1 to: n do: [:i | self doObjectCreation ].
	 1 to: n do: [:i | self doObjectCopy     ].
	 1 to: n do: [:i | self doPerform        ].
	 1 to: n do: [:i | self doBlockValue     ]
	] omni: domain.! !

!OstBenchSlopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/16/2013 12:27'!
setUp
	domain := OstDomain new.
	obj := OstObject.! !

SMarkSmopstone subclass: #OstBenchSmopstone
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Benchmarks'!

!OstBenchSmopstone class methodsFor: 'class initialization' stamp: 'StefanMarr 5/7/2013 20:23'!
initialize
	OstObject omnifyClass: self.! !

!OstBenchSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:12'!
benchStone
	[super benchStone] omni: domain.! !

!OstBenchSmopstone methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 19:28'!
setUp
	ordCollectionFact := OstOrderedCollection.
	intervalFact      := OstInterval.
	rectFactory       := OstRectangle.
	sortedColFact     := OstSortedCollection.
	arrFact           := OstArray.
	setFact           := OstSet.
	pointFact         := OstPoint.
	
	domain            := OstDomain new.! !

SMarkLoops subclass: #OstBenchLoops
	instanceVariableNames: 'domain omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'O-Benchmarks'!

!OstBenchLoops commentStamp: 'StefanMarr 9/6/2012 18:00' prior: 0!
OstBenchLoops relies on the SMarkLoops benchmarks but will execute them in the context of a domain.!

!OstBenchLoops class methodsFor: 'class initialization' stamp: 'StefanMarr 4/27/2013 19:29'!
initialize 
	OstObject omnifyClass: self.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 13:46'!
benchArrayAccess
	[| i array obj |
	
	array := OstArray new: 1.
	obj   := OstObject new.
	
	i := self problemSize.
	[i > 0] whileTrue: [
		array at: 1.
		array at: 1 put: obj.
		
		i := i - 1.
	]] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchClassVarBinding
	[super benchClassVarBinding ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchFloatLoop
	[super benchFloatLoop ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchInstVarAccess
	[super benchInstVarAccess ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:02'!
benchIntLoop
	[super benchIntLoop ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:03'!
benchSend
	[super benchSend ] omni: domain.! !

!OstBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/6/2012 18:03'!
benchSendWithManyArguments
	[super benchSendWithManyArguments ] omni: domain.! !

!OstBenchLoops methodsFor: 'running' stamp: 'StefanMarr 9/6/2012 18:01'!
setUp
	domain := OstDomain new.! !
OstBenchLoops initialize!
OstBenchSmopstone initialize!
OstBenchSlopstone initialize!
